/* ConfigStore.c generated by valac 0.34.4, the Vala compiler
 * generated from ConfigStore.vala, do not modify */

/*
 * Copyright (C) 2008,2009 Sebastian Pölsterl
 *
 * This file is part of GNOME DVB Daemon.
 *
 * GNOME DVB Daemon is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME DVB Daemon is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME DVB Daemon.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>


#define DVB_DATABASE_TYPE_CONFIG_STORE (dvb_database_config_store_get_type ())
#define DVB_DATABASE_CONFIG_STORE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_DATABASE_TYPE_CONFIG_STORE, DVBdatabaseConfigStore))
#define DVB_DATABASE_IS_CONFIG_STORE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_DATABASE_TYPE_CONFIG_STORE))
#define DVB_DATABASE_CONFIG_STORE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), DVB_DATABASE_TYPE_CONFIG_STORE, DVBdatabaseConfigStoreIface))

typedef struct _DVBdatabaseConfigStore DVBdatabaseConfigStore;
typedef struct _DVBdatabaseConfigStoreIface DVBdatabaseConfigStoreIface;

#define DVB_TYPE_DEVICE_GROUP (dvb_device_group_get_type ())
#define DVB_DEVICE_GROUP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_DEVICE_GROUP, DVBDeviceGroup))
#define DVB_DEVICE_GROUP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_TYPE_DEVICE_GROUP, DVBDeviceGroupClass))
#define DVB_IS_DEVICE_GROUP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_DEVICE_GROUP))
#define DVB_IS_DEVICE_GROUP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_TYPE_DEVICE_GROUP))
#define DVB_DEVICE_GROUP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_TYPE_DEVICE_GROUP, DVBDeviceGroupClass))

typedef struct _DVBDeviceGroup DVBDeviceGroup;
typedef struct _DVBDeviceGroupClass DVBDeviceGroupClass;

#define DVB_TYPE_DEVICE (dvb_device_get_type ())
#define DVB_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_DEVICE, DVBDevice))
#define DVB_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_TYPE_DEVICE, DVBDeviceClass))
#define DVB_IS_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_DEVICE))
#define DVB_IS_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_TYPE_DEVICE))
#define DVB_DEVICE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_TYPE_DEVICE, DVBDeviceClass))

typedef struct _DVBDevice DVBDevice;
typedef struct _DVBDeviceClass DVBDeviceClass;

#define DVB_TYPE_CHANNEL_GROUP (dvb_channel_group_get_type ())
#define DVB_CHANNEL_GROUP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_CHANNEL_GROUP, DVBChannelGroup))
#define DVB_CHANNEL_GROUP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_TYPE_CHANNEL_GROUP, DVBChannelGroupClass))
#define DVB_IS_CHANNEL_GROUP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_CHANNEL_GROUP))
#define DVB_IS_CHANNEL_GROUP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_TYPE_CHANNEL_GROUP))
#define DVB_CHANNEL_GROUP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_TYPE_CHANNEL_GROUP, DVBChannelGroupClass))

typedef struct _DVBChannelGroup DVBChannelGroup;
typedef struct _DVBChannelGroupClass DVBChannelGroupClass;

#define DVB_TYPE_CHANNEL (dvb_channel_get_type ())
#define DVB_CHANNEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_CHANNEL, DVBChannel))
#define DVB_CHANNEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_TYPE_CHANNEL, DVBChannelClass))
#define DVB_IS_CHANNEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_CHANNEL))
#define DVB_IS_CHANNEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_TYPE_CHANNEL))
#define DVB_CHANNEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_TYPE_CHANNEL, DVBChannelClass))

typedef struct _DVBChannel DVBChannel;
typedef struct _DVBChannelClass DVBChannelClass;

typedef enum  {
	DVB_DATABASE_SQL_ERROR_ERROR,
	DVB_DATABASE_SQL_ERROR_INTERNAL,
	DVB_DATABASE_SQL_ERROR_PERM,
	DVB_DATABASE_SQL_ERROR_ABORT,
	DVB_DATABASE_SQL_ERROR_BUSY,
	DVB_DATABASE_SQL_ERROR_LOCKED,
	DVB_DATABASE_SQL_ERROR_NOMEM,
	DVB_DATABASE_SQL_ERROR_READONLY,
	DVB_DATABASE_SQL_ERROR_INTERRUPT,
	DVB_DATABASE_SQL_ERROR_IOERR,
	DVB_DATABASE_SQL_ERROR_CORRUPT,
	DVB_DATABASE_SQL_ERROR_NOTFOUND,
	DVB_DATABASE_SQL_ERROR_FULL,
	DVB_DATABASE_SQL_ERROR_CANTOPEN,
	DVB_DATABASE_SQL_ERROR_PROTOCOL,
	DVB_DATABASE_SQL_ERROR_EMPTY,
	DVB_DATABASE_SQL_ERROR_SCHEMA,
	DVB_DATABASE_SQL_ERROR_TOOBIG,
	DVB_DATABASE_SQL_ERROR_CONSTRAINT,
	DVB_DATABASE_SQL_ERROR_MISMATCH,
	DVB_DATABASE_SQL_ERROR_MISUSE,
	DVB_DATABASE_SQL_ERROR_NOLFS,
	DVB_DATABASE_SQL_ERROR_AUTH,
	DVB_DATABASE_SQL_ERROR_FORMAT,
	DVB_DATABASE_SQL_ERROR_RANGE,
	DVB_DATABASE_SQL_ERROR_NOTADB
} DVBdatabaseSqlError;
#define DVB_DATABASE_SQL_ERROR dvb_database_sql_error_quark ()
struct _DVBdatabaseConfigStoreIface {
	GTypeInterface parent_iface;
	GeeList* (*get_all_device_groups) (DVBdatabaseConfigStore* self, GError** error);
	DVBDeviceGroup* (*get_device_group) (DVBdatabaseConfigStore* self, guint group_id, GError** error);
	gboolean (*is_last_device) (DVBdatabaseConfigStore* self, guint group_id, GError** error);
	gboolean (*is_group_member) (DVBdatabaseConfigStore* self, DVBDevice* dev, DVBDeviceGroup* group, GError** error);
	gboolean (*add_device_group) (DVBdatabaseConfigStore* self, DVBDeviceGroup* dev_group, GError** error);
	gboolean (*remove_device_group) (DVBdatabaseConfigStore* self, DVBDeviceGroup* devgroup, GError** error);
	gboolean (*add_device_to_group) (DVBdatabaseConfigStore* self, DVBDevice* dev, DVBDeviceGroup* devgroup, GError** error);
	gboolean (*remove_device_from_group) (DVBdatabaseConfigStore* self, DVBDevice* dev, DVBDeviceGroup* devgroup, GError** error);
	gboolean (*update_from_group) (DVBdatabaseConfigStore* self, DVBDeviceGroup* devgroup, GError** error);
	gboolean (*get_parent_groups) (DVBdatabaseConfigStore* self, guint adapter, guint frontend, guint** group_ids, int* group_ids_length1, GError** error);
	gboolean (*add_channel_group) (DVBdatabaseConfigStore* self, const gchar* name, gint* channel_group_id, GError** error);
	gboolean (*remove_channel_group) (DVBdatabaseConfigStore* self, gint group_id, GError** error);
	GeeList* (*get_channel_groups) (DVBdatabaseConfigStore* self, GError** error);
	GeeList* (*get_channels_of_group) (DVBdatabaseConfigStore* self, guint dev_group_id, gint channel_group_id, GError** error);
	gboolean (*add_channel_to_group) (DVBdatabaseConfigStore* self, DVBChannel* channel, gint group_id, GError** error);
	gboolean (*remove_channel_from_group) (DVBdatabaseConfigStore* self, DVBChannel* channel, gint group_id, GError** error);
};



GType dvb_device_group_get_type (void) G_GNUC_CONST;
GQuark dvb_database_sql_error_quark (void);
GType dvb_device_get_type (void) G_GNUC_CONST;
GType dvb_channel_group_get_type (void) G_GNUC_CONST;
GType dvb_channel_get_type (void) G_GNUC_CONST;
GType dvb_database_config_store_get_type (void) G_GNUC_CONST;
GeeList* dvb_database_config_store_get_all_device_groups (DVBdatabaseConfigStore* self, GError** error);
DVBDeviceGroup* dvb_database_config_store_get_device_group (DVBdatabaseConfigStore* self, guint group_id, GError** error);
gboolean dvb_database_config_store_is_last_device (DVBdatabaseConfigStore* self, guint group_id, GError** error);
gboolean dvb_database_config_store_is_group_member (DVBdatabaseConfigStore* self, DVBDevice* dev, DVBDeviceGroup* group, GError** error);
gboolean dvb_database_config_store_add_device_group (DVBdatabaseConfigStore* self, DVBDeviceGroup* dev_group, GError** error);
gboolean dvb_database_config_store_remove_device_group (DVBdatabaseConfigStore* self, DVBDeviceGroup* devgroup, GError** error);
gboolean dvb_database_config_store_add_device_to_group (DVBdatabaseConfigStore* self, DVBDevice* dev, DVBDeviceGroup* devgroup, GError** error);
gboolean dvb_database_config_store_remove_device_from_group (DVBdatabaseConfigStore* self, DVBDevice* dev, DVBDeviceGroup* devgroup, GError** error);
gboolean dvb_database_config_store_update_from_group (DVBdatabaseConfigStore* self, DVBDeviceGroup* devgroup, GError** error);
gboolean dvb_database_config_store_get_parent_groups (DVBdatabaseConfigStore* self, guint adapter, guint frontend, guint** group_ids, int* group_ids_length1, GError** error);
gboolean dvb_database_config_store_add_channel_group (DVBdatabaseConfigStore* self, const gchar* name, gint* channel_group_id, GError** error);
gboolean dvb_database_config_store_remove_channel_group (DVBdatabaseConfigStore* self, gint group_id, GError** error);
GeeList* dvb_database_config_store_get_channel_groups (DVBdatabaseConfigStore* self, GError** error);
GeeList* dvb_database_config_store_get_channels_of_group (DVBdatabaseConfigStore* self, guint dev_group_id, gint channel_group_id, GError** error);
gboolean dvb_database_config_store_add_channel_to_group (DVBdatabaseConfigStore* self, DVBChannel* channel, gint group_id, GError** error);
gboolean dvb_database_config_store_remove_channel_from_group (DVBdatabaseConfigStore* self, DVBChannel* channel, gint group_id, GError** error);


GeeList* dvb_database_config_store_get_all_device_groups (DVBdatabaseConfigStore* self, GError** error) {
	g_return_val_if_fail (self != NULL, NULL);
	return DVB_DATABASE_CONFIG_STORE_GET_INTERFACE (self)->get_all_device_groups (self, error);
}


DVBDeviceGroup* dvb_database_config_store_get_device_group (DVBdatabaseConfigStore* self, guint group_id, GError** error) {
	g_return_val_if_fail (self != NULL, NULL);
	return DVB_DATABASE_CONFIG_STORE_GET_INTERFACE (self)->get_device_group (self, group_id, error);
}


gboolean dvb_database_config_store_is_last_device (DVBdatabaseConfigStore* self, guint group_id, GError** error) {
	g_return_val_if_fail (self != NULL, FALSE);
	return DVB_DATABASE_CONFIG_STORE_GET_INTERFACE (self)->is_last_device (self, group_id, error);
}


gboolean dvb_database_config_store_is_group_member (DVBdatabaseConfigStore* self, DVBDevice* dev, DVBDeviceGroup* group, GError** error) {
	g_return_val_if_fail (self != NULL, FALSE);
	return DVB_DATABASE_CONFIG_STORE_GET_INTERFACE (self)->is_group_member (self, dev, group, error);
}


gboolean dvb_database_config_store_add_device_group (DVBdatabaseConfigStore* self, DVBDeviceGroup* dev_group, GError** error) {
	g_return_val_if_fail (self != NULL, FALSE);
	return DVB_DATABASE_CONFIG_STORE_GET_INTERFACE (self)->add_device_group (self, dev_group, error);
}


gboolean dvb_database_config_store_remove_device_group (DVBdatabaseConfigStore* self, DVBDeviceGroup* devgroup, GError** error) {
	g_return_val_if_fail (self != NULL, FALSE);
	return DVB_DATABASE_CONFIG_STORE_GET_INTERFACE (self)->remove_device_group (self, devgroup, error);
}


gboolean dvb_database_config_store_add_device_to_group (DVBdatabaseConfigStore* self, DVBDevice* dev, DVBDeviceGroup* devgroup, GError** error) {
	g_return_val_if_fail (self != NULL, FALSE);
	return DVB_DATABASE_CONFIG_STORE_GET_INTERFACE (self)->add_device_to_group (self, dev, devgroup, error);
}


gboolean dvb_database_config_store_remove_device_from_group (DVBdatabaseConfigStore* self, DVBDevice* dev, DVBDeviceGroup* devgroup, GError** error) {
	g_return_val_if_fail (self != NULL, FALSE);
	return DVB_DATABASE_CONFIG_STORE_GET_INTERFACE (self)->remove_device_from_group (self, dev, devgroup, error);
}


gboolean dvb_database_config_store_update_from_group (DVBdatabaseConfigStore* self, DVBDeviceGroup* devgroup, GError** error) {
	g_return_val_if_fail (self != NULL, FALSE);
	return DVB_DATABASE_CONFIG_STORE_GET_INTERFACE (self)->update_from_group (self, devgroup, error);
}


gboolean dvb_database_config_store_get_parent_groups (DVBdatabaseConfigStore* self, guint adapter, guint frontend, guint** group_ids, int* group_ids_length1, GError** error) {
	g_return_val_if_fail (self != NULL, FALSE);
	return DVB_DATABASE_CONFIG_STORE_GET_INTERFACE (self)->get_parent_groups (self, adapter, frontend, group_ids, group_ids_length1, error);
}


gboolean dvb_database_config_store_add_channel_group (DVBdatabaseConfigStore* self, const gchar* name, gint* channel_group_id, GError** error) {
	g_return_val_if_fail (self != NULL, FALSE);
	return DVB_DATABASE_CONFIG_STORE_GET_INTERFACE (self)->add_channel_group (self, name, channel_group_id, error);
}


gboolean dvb_database_config_store_remove_channel_group (DVBdatabaseConfigStore* self, gint group_id, GError** error) {
	g_return_val_if_fail (self != NULL, FALSE);
	return DVB_DATABASE_CONFIG_STORE_GET_INTERFACE (self)->remove_channel_group (self, group_id, error);
}


GeeList* dvb_database_config_store_get_channel_groups (DVBdatabaseConfigStore* self, GError** error) {
	g_return_val_if_fail (self != NULL, NULL);
	return DVB_DATABASE_CONFIG_STORE_GET_INTERFACE (self)->get_channel_groups (self, error);
}


GeeList* dvb_database_config_store_get_channels_of_group (DVBdatabaseConfigStore* self, guint dev_group_id, gint channel_group_id, GError** error) {
	g_return_val_if_fail (self != NULL, NULL);
	return DVB_DATABASE_CONFIG_STORE_GET_INTERFACE (self)->get_channels_of_group (self, dev_group_id, channel_group_id, error);
}


gboolean dvb_database_config_store_add_channel_to_group (DVBdatabaseConfigStore* self, DVBChannel* channel, gint group_id, GError** error) {
	g_return_val_if_fail (self != NULL, FALSE);
	return DVB_DATABASE_CONFIG_STORE_GET_INTERFACE (self)->add_channel_to_group (self, channel, group_id, error);
}


gboolean dvb_database_config_store_remove_channel_from_group (DVBdatabaseConfigStore* self, DVBChannel* channel, gint group_id, GError** error) {
	g_return_val_if_fail (self != NULL, FALSE);
	return DVB_DATABASE_CONFIG_STORE_GET_INTERFACE (self)->remove_channel_from_group (self, channel, group_id, error);
}


static void dvb_database_config_store_base_init (DVBdatabaseConfigStoreIface * iface) {
	static gboolean initialized = FALSE;
	if (!initialized) {
		initialized = TRUE;
	}
}


GType dvb_database_config_store_get_type (void) {
	static volatile gsize dvb_database_config_store_type_id__volatile = 0;
	if (g_once_init_enter (&dvb_database_config_store_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DVBdatabaseConfigStoreIface), (GBaseInitFunc) dvb_database_config_store_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType dvb_database_config_store_type_id;
		dvb_database_config_store_type_id = g_type_register_static (G_TYPE_INTERFACE, "DVBdatabaseConfigStore", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (dvb_database_config_store_type_id, G_TYPE_OBJECT);
		g_once_init_leave (&dvb_database_config_store_type_id__volatile, dvb_database_config_store_type_id);
	}
	return dvb_database_config_store_type_id__volatile;
}



